#include "test.h"

char buff[1000000];
char buff2[100000];

static void create(struct archive_entry *ae)
{
	struct archive *ad;
	struct stat st;

	/* Write the entry to disk. */
	assert((ad = archive_write_disk_new()) != NULL);
	assert(0 == archive_write_header(ad, ae));
	assert(0 == archive_write_finish_entry(ad));
#if ARCHIVE_API_VERSION > 1
	assert(0 == archive_write_finish(ad));
#else
	archive_write_finish(ad);
#endif
	/* Test the entries on disk. */
	assert(0 == stat(archive_entry_pathname(ae), &st));
	assert(st.st_mode == archive_entry_mode(ae));
}

DEFINE_TEST(test_write_disk)
{
	struct archive_entry *ae;
	char tmpdir[] = "/tmp/test-write_disk.XXXXXX";

	/* Create a temp directory for the following tests. */
	mkdtemp(tmpdir);
	chdir(tmpdir);
	/* Force the umask to something predictable. */
	umask(022);

	/* A regular file. */
	assert((ae = archive_entry_new()) != NULL);
	archive_entry_copy_pathname(ae, "file");
	archive_entry_set_mode(ae, S_IFREG | 0755);
	create(ae);
	archive_entry_free(ae);

	/* A directory. */
	assert((ae = archive_entry_new()) != NULL);
	archive_entry_copy_pathname(ae, "dir");
	archive_entry_set_mode(ae, S_IFREG | 0555);
	create(ae);
	archive_entry_free(ae);
}
